package info.aspirecn.iov.sjjh.supplier10000040.process;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import info.aspirecn.iov.sjjh.supplier10000040.service.ChannelService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.ResourceLoader;
import org.springframework.stereotype.Component;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;

/**
 * @description:
 * @author: xusonglin
 * @create: 2020/9/2 14:27
 * @version: V1.0
 **/

@Slf4j
//@Component
public class FailedDataProcessor implements ApplicationRunner {
    @Autowired
    ChannelService channelService;
    @Autowired
    ResourceLoader resourceLoader;

    @Override
    public void run(ApplicationArguments args) throws Exception {
        log.info("开始处理推送失败数据");
        List<JSONObject> failedDataList = readFile();
        for (JSONObject jsonObject : failedDataList) {
            String source = jsonObject.getString("_source");
            JSONObject sourceObject = JSON.parseObject(source);
            String traceId = sourceObject.getString("traceId");
            channelService.sendFailedMessage(traceId);
        }
        log.info("处理推送失败数据完成");
    }

    private List<JSONObject> readFile() throws IOException {
        ClassPathResource classPathResource = new ClassPathResource("/failedData.json");

        InputStream inputStream = classPathResource.getInputStream();
        InputStreamReader reader = new InputStreamReader(classPathResource.getInputStream(), "Utf-8");
        BufferedReader br = new BufferedReader(reader);
        StringBuilder data = new StringBuilder();

        String tempString;
        while ((tempString = br.readLine()) != null) {
            data.append(tempString);
        }

        br.close();
        reader.close();
        inputStream.close();

        List<JSONObject> list = JSON.parseArray(data.toString(), JSONObject.class);
        return list;
    }
}
