package info.aspirecn.iov.sjjh.supplier10000040.process;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.iov.sjjh.supplier10000040.constant.ChannelConstant;
import info.aspirecn.iov.sjjh.supplier10000040.model.*;
import info.aspirecn.iov.sjjh.supplier10000040.property.SupplierProperties;
import info.aspirecn.iov.sjjh.supplier10000040.util.EsOpeateUtils;
import info.aspirecn.iov.sjjh.supplier10000040.util.ExcelUtil;
import info.aspirecn.iov.sjjh.supplier10000040.util.IllegalInfoScoreUtil;
import info.aspirecn.iov.sjjh.supplier10000040.util.SendService;
import info.aspirecn.rdc.aspirecloud.node.except.utils.ErrorUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.component.file.GenericFileMessage;
import org.apache.commons.codec.binary.Base64;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import java.io.File;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @description:
 * @author: xusonglin
 * @create: 2020/4/25 21:11
 * @version: V1.0
 **/
@Slf4j
@Component
public class IllegalInfoProcessor implements Processor {
    @Value("${localDir.download}")
    private String localDownloadDir;
    @Autowired
    SupplierProperties supplierProperties;

    @Autowired
    private StringRedisTemplate redisTemplate;

    @Autowired
    private SendService sendService;

    @Autowired
    private EsOpeateUtils esOpeateUtils;

//    @Override
//    public void process(Exchange exchange) throws Exception {
//        exchange.setProperty(Exchange.CHARSET_NAME, "UTF-8");
//        GenericFileMessage<RandomAccessFile> inFileMessage = (GenericFileMessage<RandomAccessFile>) exchange.getIn();
//        //文件名
//        String fileName = inFileMessage.getGenericFile().getFileName();
//        //文件的绝对路径
//        log.info("supplier10000040.process:" + localDownloadDir + File.separator + fileName);
//        List<IllegalInfoFtpResult> illegalInfoFtpResults = ExcelUtil.readExcel(localDownloadDir + File.separator + fileName);
//        String upstreamCode = "1000";
//        for (IllegalInfoFtpResult result : illegalInfoFtpResults) {
//            ChannelTypeHandleResponseObject responseObject = responseAnalyze(result);
//            String traceId = result.getTraceId().split("-")[1];
//            AsyncReqMqMessage asyncReqMqMessage = new AsyncReqMqMessage();
//            asyncReqMqMessage.setTraceid(traceId);
//            asyncReqMqMessage.setQueryCache(false);
//            asyncReqMqMessage.setSyncReturn(false);
//            asyncReqMqMessage.setIsCharge(responseObject.getIsCharge());
//
//            String asyncReqInfoStr = (String) redisTemplate.boundHashOps("sjjh_async_request_info").get(traceId);
//            log.info("traceId:{},asyncReqInfoStr:{}", traceId, asyncReqInfoStr);
//
//            if (StringUtils.isNotEmpty(asyncReqInfoStr)) {
//                CacheStreamObject.AsyncMsg asyncReqInfo = JSON.parseObject(asyncReqInfoStr, CacheStreamObject.AsyncMsg.class);
//                CallbackDownstreamRequest request = new CallbackDownstreamRequest();
//                request.setAccessId(asyncReqInfo.getAccessId());
//                request.setTransationId(traceId);
//                request.setResultCode(responseObject.getResultCode());
//
//                if (asyncReqInfo.getIfJkCode() == 1) {
//                    String code = supplierProperties.getCode().get(String.valueOf(responseObject.getResultCode()));
//                    if (code != null) {
//                        request.setResultCode(Integer.valueOf(code));
//                    }
//
//                }
//
//                request.setResultBody(responseObject.getResultBody().toString());
//                log.info("request:{}", request);
//                asyncReqMqMessage.setCallbackResult(Base64.encodeBase64String(JSON.toJSONString(request, SerializerFeature.WriteMapNullValue).getBytes("UTF-8")));
//                String message = JSON.toJSONString(asyncReqMqMessage, SerializerFeature.WriteMapNullValue);
//                log.info("发送到kafka的message:{}", message);
//                Boolean sendResult;
//                sendResult = sendService.sendMsg(JSON.toJSONString(asyncReqMqMessage, SerializerFeature.WriteMapNullValue));
//                if (!sendResult) {//成功发起请求记录日志
//                    KafkaAccessLog kafkaAccessLog = new KafkaAccessLog();
//                    kafkaAccessLog.setType(1);
//                    kafkaAccessLog.setContent(message);
//                    String kafkaContent = JSON.toJSONString(kafkaAccessLog);
//                    long addKafkaAccessLogResult = redisTemplate.boundSetOps("Kafka_AccessLog").add(kafkaContent);
//                    log.info("kafka信息:{}发送redis是否成功:{}", message, addKafkaAccessLogResult);
//                }
//                boolean logFlag = false;
//                //修改es日志记录
//                try {
//                    logFlag = esOpeateUtils.updateByQuery(traceId, "use", responseObject.getIsCharge(), upstreamCode);
//                } catch (Exception ex) {
//                    log.error("update es 异常:{}", ex);
//                }
//                if (!logFlag) {
//                    KafkaAccessLog kafkaAccessLog = new KafkaAccessLog();
//                    kafkaAccessLog.setType(2);
//                    Map<String, String> contentMap = new HashMap<String, String>();
//                    contentMap.put("traceId", traceId);
//                    contentMap.put("ifCj", "use");
//                    contentMap.put("isCharge", String.valueOf(responseObject.getIsCharge()));
//                    String contentStr = JSON.toJSONString(contentMap);
//                    kafkaAccessLog.setContent(contentStr);
//                    String kafkaContent = JSON.toJSONString(kafkaAccessLog);
//                    long addKafkaAccessLogResult = redisTemplate.boundSetOps("Kafka_AccessLog").add(kafkaContent);
//                    log.info("log update 信息:{}是否成功:{}", contentStr, addKafkaAccessLogResult);
//                }
//            }
//            Long removeResult = redisTemplate.boundZSetOps("sjjh_async_request_traceids").remove(traceId);
//            log.info("删除sjjh_async_request_traceids:{},结果:{}", traceId, removeResult);
//        }
//    }

    @Override
    public void process(Exchange exchange) throws Exception {
        exchange.setProperty(Exchange.CHARSET_NAME, "UTF-8");
        GenericFileMessage<RandomAccessFile> inFileMessage = (GenericFileMessage<RandomAccessFile>) exchange.getIn();
        //文件名
        String fileName = inFileMessage.getGenericFile().getFileName();
        //文件的绝对路径
        log.info("supplier10000040.process:" + localDownloadDir + File.separator + fileName);
        List<IllegalInfoFtpResult> illegalInfoFtpResults = new ArrayList<>();
        try {
            illegalInfoFtpResults = ExcelUtil.readExcel(localDownloadDir + File.separator + fileName);
        } catch (Exception e) {
            ErrorUtils.captureException(e);
            log.info("supplier10000040.process读取excel失败接口Exception={}", e);
            File file = new File(localDownloadDir + File.separator + fileName);
            if (file.exists()) {
                file.delete();
            }
        }

        String upstreamCode = "1000";
        for (IllegalInfoFtpResult result : illegalInfoFtpResults) {
            ChannelTypeHandleResponseObject responseObject = responseAnalyze(result);
            String traceId = result.getTraceId().split("-")[1];

            AsyncReqMqMessage asyncReqMqMessage = new AsyncReqMqMessage();
            asyncReqMqMessage.setTraceid(traceId);
            asyncReqMqMessage.setQueryCache(false);
            asyncReqMqMessage.setSyncReturn(false);
            asyncReqMqMessage.setIsCharge(responseObject.getIsCharge());

            String asyncReqInfoStr = (String) redisTemplate.boundHashOps("sjjh_async_request_info").get(traceId);
            log.info("traceId:{},asyncReqInfoStr:{}", traceId, asyncReqInfoStr);

            if (StringUtils.isBlank(asyncReqInfoStr)) {
                continue;
            }

            if (StringUtils.isNotEmpty(asyncReqInfoStr)) {
                CacheStreamObject.AsyncMsg asyncReqInfo = JSON.parseObject(asyncReqInfoStr, CacheStreamObject.AsyncMsg.class);
                CallbackDownstreamRequest request = new CallbackDownstreamRequest();
                request.setAccessId(asyncReqInfo.getAccessId());
                request.setTransationId(traceId);
                request.setResultCode(responseObject.getResultCode());

                if (asyncReqInfo.getIfJkCode() == 1) {
                    String code = supplierProperties.getCode().get(responseObject.getResultCode());
                    if (code != null) {
                        request.setResultCode(Integer.valueOf(code));
                    }
                }

                request.setResultBody(responseObject.getResultBody().toString());
                log.info("request:{}", request);
                asyncReqMqMessage.setCallbackResult(Base64.encodeBase64String(JSON.toJSONString(request, SerializerFeature.WriteMapNullValue).getBytes("UTF-8")));
                String message = JSON.toJSONString(asyncReqMqMessage, SerializerFeature.WriteMapNullValue);
                log.info("发送到kafka的message:{}", message);
                Boolean sendResult;
                sendResult = sendService.sendMsg(JSON.toJSONString(asyncReqMqMessage, SerializerFeature.WriteMapNullValue));
                if (!sendResult) {//成功发起请求记录日志
                    KafkaAccessLog kafkaAccessLog = new KafkaAccessLog();
                    kafkaAccessLog.setType(1);
                    kafkaAccessLog.setContent(message);
                    String kafkaContent = JSON.toJSONString(kafkaAccessLog);
                    long addKafkaAccessLogResult = redisTemplate.boundSetOps("Kafka_AccessLog").add(kafkaContent);
                    log.info("kafka信息:{}发送redis是否成功:{}", message, addKafkaAccessLogResult);
                }
                boolean logFlag = false;
                //修改es日志记录
                try {
                    logFlag = esOpeateUtils.updateByQuery(traceId, "use", responseObject.getIsCharge(), upstreamCode);
                } catch (Exception ex) {
                    log.error("update es 异常:{}", ex);
                }
                if (!logFlag) {
                    KafkaAccessLog kafkaAccessLog = new KafkaAccessLog();
                    kafkaAccessLog.setType(2);
                    Map<String, String> contentMap = new HashMap<String, String>();
                    contentMap.put("traceId", traceId);
                    contentMap.put("ifCj", "use");
                    contentMap.put("isCharge", String.valueOf(responseObject.getIsCharge()));
                    String contentStr = JSON.toJSONString(contentMap);
                    kafkaAccessLog.setContent(contentStr);
                    String kafkaContent = JSON.toJSONString(kafkaAccessLog);
                    long addKafkaAccessLogResult = redisTemplate.boundSetOps("Kafka_AccessLog").add(kafkaContent);
                    log.info("log update 信息:{}是否成功:{}", contentStr, addKafkaAccessLogResult);
                } else {
                    // 修改es成功
                    String redisRequestParam = (String) redisTemplate.boundHashOps("asynchronous-illegal-info-request").get(traceId);
                    RedisParamObject redisRequestParamObject = JSON.toJavaObject(JSON.parseObject(redisRequestParam), RedisParamObject.class);
                    redisRequestParamObject.setStatus(ChannelConstant.REQUEST_STATUS_4);
                    redisRequestParamObject.setVersion(redisRequestParamObject.getVersion() + 1);
                    redisTemplate.boundHashOps("asynchronous-illegal-info-request")
                            .put(redisRequestParamObject.getTraceId(), JSON.toJSONString(redisRequestParamObject));
                    log.info("illegalInfoTask -- 修改数据流水号：{}，修改为状态：4（处理完成）");
                }
            }
            Long removeResult = redisTemplate.boundZSetOps("sjjh_async_request_traceids").remove(traceId);
            log.info("删除sjjh_async_request_traceids:{},结果:{}", traceId, removeResult);
        }
    }

    private ChannelTypeHandleResponseObject responseAnalyze(IllegalInfoFtpResult result) {
        String traceId = result.getTraceId();
        String interfaceType = traceId.split("-")[0];
        String isIdCard = String.valueOf(result.getIsIdCard());
        String isDrugs = String.valueOf(result.getIsDrugs());
        String isEscape = String.valueOf(result.getIsEscape());
        String isPedigree = String.valueOf(result.getIsPedigree());
        log.info("supplier10000040.process:上游返回结果:{}", result);
        ChannelTypeHandleResponseObject responseObject = new ChannelTypeHandleResponseObject();
        if (isIdCard.equals("2") || isDrugs.equals("2") || isEscape.equals("2") || isPedigree.equals("2")) {
            responseObject.setResultCode(Constant.OTHER_ERROR_CODE);
            responseObject.setResultBody(Constant.OTHER_ERROR);
            responseObject.setIsCharge(Constant.IS_NOT_CHARGE);
            return responseObject;
        }
        if (interfaceType.equals(ChannelConstant.ILLEGAL_INFO_SCORE)) {
            return getIllegalInfoScoreResult(result, responseObject);
        } else if (interfaceType.equals(ChannelConstant.ILLEGAL_INFO_RESULT)) {
            return getIllegalInfoResult(result, responseObject);
        } else {
            return getIllegalInfoSimple(result, responseObject);
        }

    }

    private ChannelTypeHandleResponseObject getIllegalInfoScoreResult(IllegalInfoFtpResult result, ChannelTypeHandleResponseObject responseObject) {
        String isIdCard = String.valueOf(result.getIsIdCard());
        String isDrugs = String.valueOf(result.getIsDrugs());
        String isEscape = String.valueOf(result.getIsEscape());
        String isPedigree = String.valueOf(result.getIsPedigree());
        String resultCode = isDrugs + isEscape + isPedigree;
        return IllegalInfoScoreUtil.getIllegalInfoScoreResult(resultCode, responseObject);
    }

    private ChannelTypeHandleResponseObject getIllegalInfoResult(IllegalInfoFtpResult result, ChannelTypeHandleResponseObject responseObject) {
        String isIdCard = String.valueOf(result.getIsIdCard());
        String isDrugs = String.valueOf(result.getIsDrugs());
        String isEscape = String.valueOf(result.getIsEscape());
        String isPedigree = String.valueOf(result.getIsPedigree());
        JSONObject responseResult = new JSONObject();
        responseResult.put("name", result.getName());
        responseResult.put("idCode", result.getIdCard());
        responseResult.put("isIdCard", isIdCard);
        responseResult.put("isDrugs", isDrugs);
        responseResult.put("isEscape", isEscape);
        responseResult.put("isPedigree", isPedigree);

        responseObject.setResultCode(Constant.SUCCESS);
        responseObject.setResultBody(JSON.toJSONString(responseResult));
        responseObject.setIsCharge(Constant.IS_CHARGE);

        return responseObject;
    }

    private ChannelTypeHandleResponseObject getIllegalInfoSimple(IllegalInfoFtpResult result, ChannelTypeHandleResponseObject responseObject) {
        String isIdCard = String.valueOf(result.getIsIdCard());
        String isDrugs = String.valueOf(result.getIsDrugs());
        String isEscape = String.valueOf(result.getIsEscape());
        String isPedigree = String.valueOf(result.getIsPedigree());

        if (isDrugs.equals("1") || isEscape.equals("1") || isPedigree.equals("1")) {
            responseObject.setResultBody("是");
        } else {
            responseObject.setResultBody("否");
        }
        responseObject.setResultCode(Constant.SUCCESS);
        responseObject.setIsCharge(Constant.IS_CHARGE);
        return responseObject;
    }
}
