package info.aspirecn.iov.sjjh.supplier10000040.util;

import info.aspirecn.rdc.aspirecloud.node.except.utils.ErrorUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.stream.annotation.EnableBinding;
import org.springframework.cloud.stream.messaging.Source;
import org.springframework.messaging.support.MessageBuilder;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Slf4j
@Component
@EnableBinding(Source.class)
public class SendService {
    @Resource
    private Source source;

    public Boolean sendMsg(String msg) {
        log.info("sendMsg===={}", msg);
        log.info("source==={}", source);
        try {
            msg = new String(msg.getBytes("utf-8"), "utf-8");
            log.info("msg==={}", msg);
            boolean send1 = source.output().send(MessageBuilder.withPayload(msg).build());
            return send1;

        } catch (Exception e) {
            log.error("发送到kafka异常, 异常信息{}", e);
            ErrorUtils.captureException(e);
            return false;
        }
    }
}
