package info.aspirecn.iov.sjjh.supplier10000040.util;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;

import java.util.concurrent.LinkedBlockingDeque;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 * @author xusonglin
 * @version V1.0
 **/
@Configuration
@EnableAsync
public class ThreadPoolConfig {
    @Value("${thread.pool.coreSize}")
    private Integer coreSize;

    @Value("${thread.pool.maximumPoolSize}")
    private Integer maximumPoolSize;

    @Value("${thread.pool.queueSize}")
    private Integer queueSize;

    @Bean("mainThreadPoolExecutor")
    public ThreadPoolExecutor mainThreadPoolExecutor() {
        LinkedBlockingDeque<Runnable> deque = new LinkedBlockingDeque<>(queueSize);

        return new ThreadPoolExecutor(coreSize,
                maximumPoolSize, 10,
                TimeUnit.MINUTES, deque);
    }
}
